<template lang="pug">
svg.x-timeline(width='100%' height='100%')
  state
    //- transition(v-pre timing-function='ease-in-out' type='strict' duration='.2')
    property(ref='value' name='value' type='number' min='0' max='1' initial='0')
      transform(query-selector='#arrow' attribute-type='CSS' from='translate(0, 0)' to='translate(100%, 0)')
    property(name='isComputed' type='boolean' :initial='false')
      relation(query-selector='#arrow #path' attribute-name='fill' from='#7D8084' to='#CED4DA')
  defs
    filter#shadow(primitiveUnits='objectBoundingBox' filterUnits='objectBoundingBox' x='-50%' y='-50%' width='400%' height='400%')
      feDropShadow(dx=".2" dy=".15" stdDeviation=".1" flood-opacity=".5")
    radialGradient#radial(cy='30%' r='70%')
      stop(style="stop-color:#ffffff;stop-opacity:0.75" offset="0")
      stop(style="stop-color:#ffffff;stop-opacity:0" offset="100%")
  TimeLineMarker(:key='kt' v-for='(kt, idx) in keyTimes'
                 :keyTime='kt' :value='getValueAtIndex(idx)'
                 @select='nset(kt)')
  g#arrow(:class='{ "b-clickable": !isComputed }')
    title
      | key-time: {{ normalizedValue }}
      | property-value: {{ value }}
    g
      // handle
      rect(x='-1em' y='0' width='2em' height='90%' fill='transparent')
      rect(x='-.125em' y='0' width='.25em' height='90%' fill='#808080')
      rect(x='-.125em' y='0' width='.25em' height='90%' fill='url(#radial)')
    g
      svg(
        preserveAspectRatio='xMidYMin meet' x='-2em' y="0" width='4em' height='4em' viewBox='-10 0 20 20')
        path#path(d="M 0 10 L 5 0 L -5 0 L 0 10 Z" stroke='#808080' stroke-width='.1em')
        path(d="M 0 10 L 5 0 L -5 0 L 0 10 Z" fill='url(#radial)')
    g
      svg(
        preserveAspectRatio='xMidYMin meet' x='-2em' y="100%" width='4em' style='transform: translateY(-4em)' height='4em' viewBox='-10 0 20 20')
        path#path(d="M 0 10 L 5 20 L -5 20 L 0 10 Z" stroke='#808080' stroke-width='.1em')
        path(d="M 0 10 L 5 20 L -5 20 L 0 10 Z" fill='url(#radial)')
</template>
<script>

export { default } from "./TimeLine.vue.js";

</script>
<style>
svg.x-timeline, .x-timeline-marker {
  overflow: visible !important;
}

#arrow g, .x-timeline-marker {
  filter: drop-shadow(3px 3px 3px #888);
}

#arrow:hover g, .x-timeline-marker:hover {
  /* filter: url(#shadow) */
  filter: drop-shadow(4px 4px 4px #666);

}

</style>
